using System;
using System.Drawing;
using System.IO;
using System.Windows.Forms;
using fomm.Scripting;

class Script : BBCInstallBaseScript
{
    public static bool install;

    public static String title = "Bert's Breezehome Cellar Final";

    // BBR MENU SETTINGS
    public static Form installBBCForm;
    public static PictureBox backgroundBBCPicture1;
    public static Button okButton;
    public static Button cancelButton;
    public static Panel optionsPanel;
    public static CheckBox CheckBoxCellarPlusUpdate;
    public static CheckBox CheckBoxGarden;
    public static CheckBox CheckBoxGardenCheat;
    public static CheckBox CheckBoxDeutsche;
    public static CheckBox CheckBoxClaude;
    public static CheckBox CheckBoxGreen;

    public static Image GetImageFromFomod(string filename)
    {
        byte[] data = GetFileFromFomod(filename);
        MemoryStream s = new MemoryStream(data);
        Image img = Image.FromStream(s);
        s.Close();
        return img;
    }

    public static void CreateinstallBBCForm()
    {

        installBBCForm = CreateCustomForm();

        installBBCForm.FormBorderStyle = FormBorderStyle.None;
        installBBCForm.StartPosition = FormStartPosition.CenterScreen;
        installBBCForm.TransparencyKey = System.Drawing.SystemColors.Control;
        installBBCForm.Size = new Size(600, 600);
        installBBCForm.Text = title;

        CheckBoxCellarPlusUpdate = new CheckBox();
        CheckBoxCellarPlusUpdate.Checked = true;
        CheckBoxCellarPlusUpdate.Enabled = false;
        CheckBoxCellarPlusUpdate.Location = new Point(353, 153);
        CheckBoxCellarPlusUpdate.Size = new Size(12, 12);
        installBBCForm.Controls.Add(CheckBoxCellarPlusUpdate);

        CheckBoxGarden = new CheckBox();
        CheckBoxGarden.Checked = false;
        CheckBoxGarden.Location = new Point(353, 208);
        CheckBoxGarden.Size = new Size(12, 12);
        installBBCForm.Controls.Add(CheckBoxGarden);

        optionsPanel = new Panel();
        optionsPanel.Location = new Point(340, 286);
        optionsPanel.Size = new Size(212, 22);
        optionsPanel.BackColor = Color.Black;
        optionsPanel.BorderStyle = BorderStyle.FixedSingle;
        installBBCForm.Controls.Add(optionsPanel);

        okButton = new Button();
        okButton.Text = "Install";
        okButton.BackColor = Color.Silver;
        okButton.UseVisualStyleBackColor = true;
        okButton.Location = new Point(0, 0);
        okButton.Size = new Size(105, 20);

        cancelButton = new Button();
        cancelButton.Text = "Cancel";
        cancelButton.BackColor = Color.Silver;
        cancelButton.UseVisualStyleBackColor = true;
        cancelButton.Location = new Point(105, 0);
        cancelButton.Size = new Size(105, 20);

        optionsPanel.Controls.Add(okButton);
        optionsPanel.Controls.Add(cancelButton);
        backgroundBBCPicture1 = new PictureBox();
        backgroundBBCPicture1.Location = new Point(0, 0);
        backgroundBBCPicture1.Size = new Size(600, 600);
        // load picture file from .fomod and stream into picture box
        backgroundBBCPicture1.Image = GetImageFromFomod("fomod/InstallerBckGrnd.jpg");
        // add BackgroundPicture to list of controls
        installBBCForm.Controls.Add(backgroundBBCPicture1);
        // CheckBox menu

        AttachHandlers();
    }

    public static void AttachHandlers()
    {

        //Attach a handler that will fire when the apply button is clicked
        okButton.Click += delegate(object sender, EventArgs args)
        {

            install = true;
            installBBCForm.Close();
        };

        cancelButton.Click += delegate(object sender, EventArgs args)
        {
            install = false;
            installBBCForm.Close();
        };
    }
    public static void PerformCustomInstall()
    {

        {
            if (CheckBoxCellarPlusUpdate.Checked)
            {

            CopyDataFile("Data/BertsBreezeCellar.v.1.0(esm).esm", "BertsBreezeCellar.v.1.0(esm).esm");
            CopyDataFile("Data/BertsBreezeCellar(esp.V3.0).esp", "BertsBreezeCellar(esp.V3.0).esp");
            CopyDataFile("Data/BertsBreezeCellar(esp.V3.0).bsa", "BertsBreezeCellar(esp.V3.0).bsa");
            CopyDataFile("Data/BertsBreezeCellar(esp.V3.0).bsl", "BertsBreezeCellar(esp.V3.0).bsl");

            CopyDataFile("BBCInstaller/Bert's Breezehome Cellar Installer Readme.Final.txt", "Bert's Breezehome Cellar Installer Readme.Final.txt");
        }
        }
        {
            if (CheckBoxGarden.Checked)
            {
            CopyDataFile("Data/BertsBreezehomeCellar(Grotto).esp", "BertsBreezehomeCellar(Grotto).esp");
            CopyDataFile("Data/BertsBreezehomeCellar(Grotto).bsa", "BertsBreezehomeCellar(Grotto).bsa");
            CopyDataFile("Data/BertsBreezehomeCellar(Grotto).bsl", "BertsBreezehomeCellar(Grotto).bsl");
        }
        }

    }
              public static bool OnActivate()
    {
        CreateinstallBBCForm();
        installBBCForm.ShowDialog();
        if(install)
        {
            PerformCustomInstall();
        }
        return install;
    }
}
